zoukankan      html  css  js  c++  java
  • LeetCode 877. Stone Game

    原题链接在这里:https://leetcode.com/problems/stone-game/

    题目:

    Alex and Lee play a game with piles of stones.  There are an even number of piles arranged in a row, and each pile has a positive integer number of stones piles[i].

    The objective of the game is to end with the most stones.  The total number of stones is odd, so there are no ties.

    Alex and Lee take turns, with Alex starting first.  Each turn, a player takes the entire pile of stones from either the beginning or the end of the row.  This continues until there are no more piles left, at which point the person with the most stones wins.

    Assuming Alex and Lee play optimally, return True if and only if Alex wins the game.

    Example 1:

    Input: [5,3,4,5]
    Output: true
    Explanation: 
    Alex starts first, and can only take the first 5 or the last 5.
    Say he takes the first 5, so that the row becomes [3, 4, 5].
    If Lee takes 3, then the board is [4, 5], and Alex takes 5 to win with 10 points.
    If Lee takes the last 5, then the board is [3, 4], and Alex takes 4 to win with 9 points.
    This demonstrated that taking the first 5 was a winning move for Alex, so we return true.

    Note:

    1. 2 <= piles.length <= 500
    2. piles.length is even.
    3. 1 <= piles[i] <= 500
    4. sum(piles) is odd.

    题解:

    There are even number of piles. 

    Person A picks first, he could either pick all the odd index piles or even index piles.

    Thus, A could choose a larger one so the person pick first always win.

    Use DP, dp[i][j] means largest sum from pile i to pile j. It could be obtained from either choosing piles[i] - dp[i+1][j], since dp[i+1][j] is the other player's turn. Or choosing pile[j] - dp[i][j-1].

    Time Complexity: O(n^2). n = piles.length.

    Space: O(n^2).

    AC Java:

     1 class Solution {
     2     public boolean stoneGame(int[] piles) {
     3         int n = piles.length;
     4         int [][] dp = new int[n][n];
     5         for(int i = 0; i<n; i++){
     6             dp[i][i] = piles[i];
     7         }
     8         
     9         for(int size = 1; size<n; size++){
    10             for(int i = 0; i+size<n; i++){
    11                 dp[i][i+size] = Math.max(piles[i]-dp[i+1][i+size], piles[i+size]-dp[i][i+size-1]);
    12             }
    13         }
    14         
    15         return dp[0][n-1] > 0;
    16     }
    17 }

    类似Predict the Winner.

    跟上Stone Game II.

  • 相关阅读:
    js字符串函数
    js流程语句
    js数组
    js变量
    js运算符
    Time.deltaTime和Time.realtimeSinceStartup
    Prefabs实例化 ResourceMgr
    SLua
    判断物体是否在摄像机内
    [Unity3D]引擎崩溃、异常、警告、BUG与提示总结及解决方法
  • 原文地址:https://www.cnblogs.com/Dylan-Java-NYC/p/11434019.html
Copyright © 2011-2022 走看看